package ihmexamples.layouts;

import java.awt.*;

/**
 * Exemple d'usage du GridBagLayout, base sur le Tutorial SUN Java
 * @see http://java.sun.com/docs/books/tutorial/uiswing/examples/layout/index.html
 */
public class GridBagLayoutDemoAWT {

    final static boolean shouldFill = true;
    final static boolean shouldWeightX = true;

    public static void addComponentsToPane(Container pane) {
        pane.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);

        Button button;
        pane.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
       
        button = new Button("Button 1");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 0;
        c.gridy = 0;
        pane.add(button, c);

        button = new Button("Button 2");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 0;
        pane.add(button, c);

        button = new Button("Button 3");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.weightx = 100; 
        c.gridx = 2;
        c.gridy = 0;
        pane.add(button, c);

        button = new Button("Long-Named Button 4");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.ipady = 40;      //make this component tall
        c.weightx = 0.0;
        c.gridwidth = 3;
        c.gridx = 0;
        c.gridy = 1;
        pane.add(button, c);

        button = new Button("5");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.ipady = 0;       //reset to default
        c.weighty = 1.0;   //request any extra vertical space
        c.anchor = GridBagConstraints.PAGE_END; //bottom of space
        c.insets = new Insets(10, 0, 0, 0);  //top padding
        c.gridx = 1;       //aligned with button 2
        c.gridwidth = 2;   //2 columns wide
        c.gridy = 2;       //third row
        pane.add(button, c);
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Create and set up the window.
        Frame frame = new Frame("GridBagLayoutDemo");
        Panel pane = new Panel();

        frame.add(pane);
        frame.addWindowListener(new ExternalWindowListner());
        //Set up the content pane.
        addComponentsToPane(pane);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {

        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                createAndShowGUI();
            }
        });
    }
}
