/*
UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
MIAGE - UFR 27
Cours ISI5 / INF2 - Developpement d'Interface

 */
package ihmexamples.properties;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListModel;

/**
 * Exemle d'usage des properties pour le stockage des donnes de configuration
 * @author kirsch
 */
public class PropertiesDemo {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
    }
    
    public Enumeration getKeysValues () {
        return model.getAllKeys();
    }
    
    PropertiesModel model;
    PropertiesView view;
}

class PropertiesModel {

    static String DEFAULTTITLE_KEY = "frame.title";
    static String DEFAULTTITLE_VALUE = "Properties Demo";
    static String DEFAULTWIDTH_KEY = "frame.width";
    static String DEFAULTWIDTH_VALUE = "300";
    static String DEFAULTHEIGTH_KEY = "frame.height";
    static String DEFAULTHEIGTH_VALUE = "300";
    static String DEFAULTUSERNAME_KEY = "user.name";
    Properties settings;

    public PropertiesModel() {
        Properties defaultsettings = loadDefaultProperties();
        settings = new Properties(defaultsettings);
    }

    public PropertiesModel(String path) {
        this();
        File propfile = new File(path);
        if (propfile.exists()) {
            try {
                FileInputStream in = new FileInputStream(propfile);
                settings.load(in);
            } catch (FileNotFoundException ex) {
                Logger.getLogger(PropertiesModel.class.getName()).log(Level.SEVERE,
                        "Impossible d'ouvrir fichier de propriete", ex);
            } catch (IOException ioex) {
                Logger.getLogger(PropertiesModel.class.getName()).log(Level.SEVERE,
                        "Impossible de lire le fichier de propriete", ioex);
            }
        }
    }

    Properties loadDefaultProperties() {
        Properties defaultsettings = new Properties();
        defaultsettings.put(DEFAULTTITLE_KEY, DEFAULTTITLE_VALUE);
        defaultsettings.put(DEFAULTWIDTH_KEY, DEFAULTWIDTH_VALUE);
        defaultsettings.put(DEFAULTHEIGTH_KEY, DEFAULTHEIGTH_VALUE);
        defaultsettings.put(DEFAULTUSERNAME_KEY, loadUserName());
        return (defaultsettings);
    }

    String loadUserName() {
        String username = "";
        username = System.getProperty("user.name", "User");
        return (username);
    }

    String get(String key) {
        return settings.getProperty(key);
    }

    void put(String key, String value) {
        settings.put(key, value);
    }
    
    Enumeration getAllKeys () {
        return settings.keys();
    }

    void save(String path, String comment) {
        File propfile = new File(path);

        try {
            FileOutputStream out = new FileOutputStream(propfile);
            settings.store(out, comment);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(PropertiesModel.class.getName()).log(Level.SEVERE,
                    "Impossible d'ouvrir fichier de propriete", ex);
        } catch (IOException ioex) {
            Logger.getLogger(PropertiesModel.class.getName()).log(Level.SEVERE,
                    "Impossible d'enregistrer fichier de propriete", ioex);
        }

    }
}

class PropertiesView extends JFrame {
    JList jList;
    JScrollPane jScroll;
    PropertiesDemo controller;

    PropertiesView (PropertiesDemo controller) {
        this.controller = controller;
        ListModel listmodel = new DefaultListModel();
    }
}