/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 * Cours ISI5 / INF2 - Developpement d'Interface
 */

package ihmexamples.tempconverter.converterswing;

/**
 * Temperature Converter keeps track of a given temperature in °C or °F
 * and supplies methods for converting from °C to °F and vice-versa
 * @author kirsch
 */

import ihmexamples.tempconverter.*;



public class TempConverterSwingGUIv2 extends javax.swing.JFrame {

    private javax.swing.JButton optCelsius;
    private javax.swing.JButton optFahrenheit;
    private javax.swing.JLabel resultat;
    private javax.swing.JPanel panel1;
    private javax.swing.JTextField textField1;

    /** Creates new form TempConverterAwtGUI */
    public TempConverterSwingGUIv2() {
        initComponents();
    }

    private void initComponents() {

        panel1 = new javax.swing.JPanel();
        textField1 = new javax.swing.JTextField();
        optCelsius = new javax.swing.JButton();
        optFahrenheit = new javax.swing.JButton();
        resultat = new javax.swing.JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        java.awt.GridBagConstraints gridBagConstraints;

        panel1.setLayout(new java.awt.BorderLayout());

        textField1.setText("");
        textField1.setColumns(10);

        optCelsius.setText("to Celsius");
        optFahrenheit.setText("to Fahrenheit");

        resultat.setText("                 ");

        setLayout(new java.awt.GridBagLayout());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(textField1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 40;
        add(resultat, gridBagConstraints);
        //add(resultat, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        add(optCelsius, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(optFahrenheit, gridBagConstraints);

        //setMinimumSize(new Dimension(300,150));
        setSize(400,150);

        //pack();


         addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        optCelsius.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optCelsiusActionPerformed(evt);
            }
        });

        optFahrenheit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optFahrenheitActionPerformed(evt);
            }
        });

    }

    private void convert (boolean celsius){
        String stringTemp = textField1.getText();
        double result=0;

        try
        {
            double temp = new Double(stringTemp).doubleValue();

            TemperatureConverter tmpc = new TemperatureConverter(temp);

            if (celsius==true)
            {
                result = tmpc.toCelcius();
            }
            else
            {
                result = tmpc.toFahrenheit();
            }
            resultat.setText(Double.toString(result));
        }
        catch (NumberFormatException ex)
        {
            resultat.setText("valeur incorrecte");
        }
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    private void optCelsiusActionPerformed(java.awt.event.ActionEvent evt) {
        convert(true);
    }

    private void optFahrenheitActionPerformed(java.awt.event.ActionEvent evt) {
        convert(false);
    }


    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                TempConverterSwingGUIv2 TC = new TempConverterSwingGUIv2();
                TC.setVisible(true);
            }
        });
    }
}
