/*
UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
MIAGE - UFR 27
Cours ISI5 / INF2 - Developpement d'Interface

 */
package ihmexamples.volumeapplication;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JSlider;
import javax.swing.SwingConstants;

/**
 * Example d'usage du modele MVC
 * Cette classe definit une vue basé sur un "Slider", une "barre" deroulante qui
 * pour visualiser et modifier la valeur du modele de volume
 *
 * @author kirsch
 */
public class VolumeSliderView extends VolumeView {

    JFrame jFrame;
    JSlider jSlider;

    public VolumeSliderView(VolumeController controller) {
        this(controller, 0);
    }

    public VolumeSliderView(VolumeController controller, int volume) {
        super(controller);
        this.buildFrame(volume);
    }

    private void buildFrame(int volume) {
        this.jFrame = new JFrame();
        jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        /* on definit le layoutmanager avec 2x plus d'espace vert. et horiz. */
        BorderLayout border = new BorderLayout();
        border.setHgap(border.getHgap() * 2);
        border.setVgap(border.getVgap() * 2);
        jFrame.setLayout(border);

        //JSlider(int min, int max, int value)
        this.jSlider = new JSlider(0, 100, volume);
        this.jSlider.setOrientation(SwingConstants.HORIZONTAL);

        JButton jButton = new JButton("Change");
        jButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                notifyVolumeChange();
            }
        });
        
        jFrame.add(jSlider, BorderLayout.CENTER);
        jFrame.add(jButton, BorderLayout.SOUTH);

        jFrame.pack();
    }

    private void notifyVolumeChange() {
        this.getController().notifyVolumeChange(jSlider.getValue());
    }

    public void volumeChanged(VolumeChangedEvent event) {
        this.jSlider.setValue(event.getNewVolume());
    }

    @Override
    public void display() {
        this.jFrame.setVisible(true);
    }

    @Override
    public void close() {
        this.jFrame.setVisible(false);
    }

    @Override
    public void setLocation(int x, int y) {
        this.jFrame.setLocation(x, y);
    }

    @Override
    public void setSize(Dimension d) {
        this.jFrame.setSize(d);
    }

    @Override
    public Dimension getSize() {
        return this.jFrame.getSize();
    }
}
